明经CAD社区

 找回密码
 注册

QQ登录

只需一步,快速开始

搜索
查看: 645|回复: 3

[讨论] 请大侠指点:下面的代码为何不能输入0

[复制链接]
发表于 2021-12-13 23:56:15 | 显示全部楼层 |阅读模式
偏移量输入默认值0就运行不了,为什么呢?输入不为0的数值都正常
(defun c:O ()
        (setq x(getreal (strcat "输入水平偏移:<" (rtos 0) ">")))
        (setq y(getreal (strcat "输入垂直偏移:<" (rtos 0) ">")))
        (setq cp(getpoint "选择基点:"))
        (setq px1(car cp))
        (setq py1(cadr cp))
        (setq mx(+ px1 x))
        (setq my(+ py1 y))
        (setq mpt(list mx my))
        (command "LINE" mpt PAUSE "")
        (princ)
)  
发表于 2021-12-14 11:39:58 | 显示全部楼层
(defun c:O (/ cp x y)
        (setq x (if (= (setq x (getreal (strcat "\n输入水平偏移:<" (rtos 0) ">"))) nil) 0 x))
        (setq y (if (= (setq y (getreal (strcat "\n输入水平偏移:<" (rtos 0) ">"))) nil) 0 y))
        (setq cp (getpoint "\n选择基点:"))
        (command "LINE" (list (+ (car cp) x) (+ (cadr cp) y)) PAUSE "")
        (princ)
)
回复 支持 1 反对 0

使用道具 举报

发表于 2021-12-14 10:56:23 | 显示全部楼层
x y 默认值没有设置,直接确认,输入为空
发表于 2021-12-14 16:22:58 | 显示全部楼层

fangmin723為基礎
(defun c:O (/ cp x y)
       (if (not x) (setq x 0))  ;增加這一行
        (if (not y) (setq y 0))  ;增加這一行

        (setq x (if (= (setq x (getreal (strcat "\n输入水平偏移:<" (rtos x) ">"))) nil) 0 x)) ;(rtos 0)改成(rtos x)
        (setq y (if (= (setq y (getreal (strcat "\n输入水平偏移:<" (rtos y) ">"))) nil) 0 y)) ;(rtos 0)改成(rtos y) 就可以記憶上次輸入的值了
        (setq cp (getpoint "\n选择基点:"))
        (command "LINE" (list (+ (car cp) x) (+ (cadr cp) y)) PAUSE "")
        (princ)
)
您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号 )  
©2000-2023 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2024-11-15 01:47 , Processed in 0.326276 second(s), 25 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

快速回复 返回顶部 返回列表